unit u_charset;

{
 TEA   
  
       (public domain)
}


interface

function get_enc (s: string): string;
function ansi2KOI (const s: string): string;
function KOI2ANSI (const s: string): string;
function IBM2ANSI (const s: string): string;
function ANSI2IBM (const s: string): string;
function KOI8U2ANSI(const  s: string): string;
function ANSI2KOI8U (const str: string): string;


implementation

uses JclUnicode, JclStrings, classes, sysutils, u_globals;

{
   ansi2KOI, KOI2ANSI, IBM2ANSI  ANSI2IBM 
    Delpi,    ,
 4 (31.01.00) :  
}


const
     Koi = '';
     Win = '';
     SerH = '';
     SerL = '';


{
function charset_conv_to_locale (s: string; page: word): string;
begin
     result := TranslateString (s, page, KeyboardCodePage);
end;
}

function ansi2KOI (const s: string): string;
var
    i, l: integer;
    k: byte;
begin
     result := s;
     l := Length (result);
     for i := 1 to l do
         begin
              k := byte(result[i]);
              if k = $B8 then result[i] := char($A3) else
              if k = $A8 then result[i] := char($B3) else
              if k > $BF then result[i] := Win[k - $BF];
         end;
end;


function KOI2ANSI (const s: string): string;
var
   i, l: integer;
   k: byte;
begin
     result := s;
     l := Length (result);
     for i := 1 to l do
         begin
              k := byte(result[i]);
              if k = $A3 then result[i] := '' else
              if k = $B3 then result[i] := '' else
              if k > $BF then result[i] := Koi[k - $BF];
         end;
end;


function ANSI2IBM (const s: string): string;
var
   i, l: integer;
   k: byte;
begin
     result := s;
     l := Length (result);
     for i := 1 to l do
         begin
              k := byte (result[i]);
              if k = $B8 then result[i] := char($F1) else
              if k = $A8 then result[i] := char($F0) else
              if k > $EF then result[i] := char (k - 16) else
              if (k > $BF) and (k < $F0) then result[i] := char(k - 64);
        end;
end;


function IBM2ANSI (const s: string): string;
var
    i,l: integer;
    k: byte;
begin
     result := s;
     l := Length (result);
     for i := 1 to l do
         begin
              k := byte(result[i]);
              if k = $F0 then result[i] := '' else
              if k = $F1 then result[i] := '' else
              if (k > $7F) and (k < $A0) then result[i] := SerH[k - $7F] else
              if (k > $9F) and (k < $B0) then result[i] := SerL[k - $9F] else
              if (k > $DF) and (k < $F0) then result[i] := SerL[k - $CF];
         end;
end;


function IsKOI (const s: string): boolean;
var
   a: array [1..13] of string;
   i: integer;
begin
     result := FALSE;

     a[1] := '  ';
     a[2] := '  ';
     a[3] := '  ';
     a[4] := '  ';
     a[5] := '  ';
     a[6] := '  ';
     a[7] := '  ';
     a[8] := '  ';
     a[9] := '  ';
     a[10] := '  ';
     a[11] := '  ';
     a[12] := '  ';
     a[13] := '  ';

     for i := 1 to 13 do
         if pos (a[i], s) <> 0 then
            begin
                 Result := TRUE;
                 Exit;
            end;
end;


function IsDOS (const s: string): boolean;
var
   a: array [1..9] of string;
   i: integer;
begin
     result := FALSE;

     a[1] := '';
     a[2] := '';
     a[3] := '';
     a[4] := '';
     a[5] := '';
     a[6] := '';
     a[7] := '';
     a[8] := '';
     a[9] := '';

     for i:= 1 to 9 do
         if pos (a[i], s) <> 0 then
            begin
                  Result := TRUE;
                  Exit;
            end;
end;


function get_enc (s: string): string;
begin
     result := c_enc_ansi;

     if IsDOS(s) then result := c_enc_oem;
     if IsKOI(s) then result := c_enc_koi8r;
end;


function KOI8U2ANSI(const  s: string): string;
var
   i: integer;
   k, l: byte;
begin
     result := s;
     l := Length (result);
     for i := 1 to l do
         begin
              k := byte (result[i]);

              case k of
                  $A3: result[i] := '';
                  $B3: result[i] := '';
                  164: result[i] := '';
                  180: result[i] := '';
                  166: result[i] := '';
                  182: result[i] := '';
                  167: result[i] := '';
                  183: result[i] := '';
                  173: result[i] := '';
                  189: result[i] := '';
                  $BF: result[i] := koi[k - $BF];
              end;
         end;
end;


function char_ANSI2KOI8U (c: char): char;
var k: byte;
begin
     result:=c;
     k := byte(c);

     if k = $B8 then result := char($A3) else
     if k = $A8 then result := char($B3) else

     if c = '' then result:= #$A3 else
     if c = '' then result:= #$B3 else

     if c ='' then result:=#164 else
     if c ='' then result:=#180 else

     if c='' then result:=#166 else
     if c='' then result:=#182 else

     if c ='' then result:=#167 else
     if c='' then result:=#183 else

     if c ='' then  result:=#173 else
     if c='' then  result:=#189 else


     if k > $BF then result := Win[k - $BF];

end;


function ANSI2KOI8U (const str: string): string;
var
   i, l: integer;
begin
  result := str;
  l := length (str);
  for i := 1 to l do
      result [i] := char_ANSI2KOI8U(str[i]);

end;


//find out where is that "cut" function. From a what lib?
{
function html_encoded_to_text(const s:string):string;
var sl:TStringList;
    c,i:integer;
    t,p:string;
    x,y:integer;
    W: WideChar;

begin
     sl:=TStringList.Create;
     StrToStrings (S,';', sl,true);
     result:='';
     c:=sl.Count-1;
     for i:=0 to c do
         begin
              t:=sl[i];

              y:=pos('&',t);
              if y<>-1 then
                 begin
                      p:=copy(t,1,y-1);
                      result:=result+p;
                 end;


              t:=Sysutils.trim(t);
              Cut (t,1,2);
              if t='' then continue;


              x:=StrToInt(t);


              if x>255 then
                begin
                     W:= WideChar(x);
                     t:=WideCharLenToString(@W, 1);
                     result:=result+t;
                end
              else
              result:=result+char(x);

         end;


     sl.Free;
end;


{
function html_hex_encoded_to_text(const s:string):string;
var sl:TStringList;
    c,i:integer;
    t,p:string;
    x,y:integer;
    W: WideChar;

begin
     sl:=TStringList.Create;
     StrToStrings(S,';', sl,true);
     result:='';
     c:=sl.Count-1;
     for i:=0 to c do
         begin
              t:=sl[i];


              y:=pos('&',t);
              if y<>-1 then
                 begin
                      p:=copy(t,1,y-1);
                      result:=result+p;
                 end;


              t:=Sysutils.trim(t);
              Cut(t,1,2);
              if t='' then continue;


              x:=HexToInt(t);


              if x>255 then
                begin
                     W:= WideChar(x);
                     t:=WideCharLenToString(@W, 1);
                     result:=result+t;
                end
              else
              result:=result+char(x);

         end;


     sl.Free;
end;
 }



end.
