unit u_fm_convert;

{
 TEA   
  
       (public domain)
}


interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Mask, JvExMask, JvToolEdit, ExtCtrls;

type
  Tfm_convert = class(TForm)
    JvDirectoryEdit1: TJvDirectoryEdit;
    bt_encode: TButton;
    ProgressBar1: TProgressBar;
    Panel1: TPanel;
    cmb_from: TComboBox;
    cmb_to: TComboBox;
    l_from: TLabel;
    l_to: TLabel;
    ed_mask: TEdit;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure bt_encodeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fm_convert: Tfm_convert;

implementation

{$R *.dfm}

uses
     u_form_main, jclFileUtils, jclStrings,
     u_charset, u_globals, u_functions;


procedure Tfm_convert.FormCreate(Sender: TObject);
begin
     cmb_from.Items.AddStrings (fm_main.encodings);
     cmb_to.Items.AddStrings (fm_main.encodings);
     cmb_from.ItemIndex := 0;
     cmb_to.ItemIndex := 0;
     JvDirectoryEdit1.Text := GetCurrentDir;
end;


procedure Tfm_convert.bt_encodeClick(Sender: TObject);
var
   List: TStrings;
   i, c: integer;
   t, x: string;
   filename: string;
begin
     if cmb_from.ItemIndex = cmb_to.ItemIndex then
        exit;

     ProgressBar1.position := 0;

     List := TStringList.Create;
//     if not BuildFileList(JvDirectoryEdit1.Text + '\*.*', faAnyFile, List) then
     if not AdvBuildFileList (JvDirectoryEdit1.Text + '\' + ed_mask.Text, faAnyFile, list, amAny, [flFullNames, flRecursive]) then
        begin
             list.free;
             exit;
        end;

     c := list.count - 1;

     for i := 0 to c do
         begin
              filename := list [i];//JvDirectoryEdit1.Text + '\' + list [i];

              if is_image (filename) or IsDirectory (filename) then
                 continue;

              t := FileToString (filename);

              x := t;

              if cmb_from.Text = c_enc_koi8r then
                 x := KOI2ANSI (t);

              if cmb_from.Text = c_enc_koi8u then
                 x := KOI8U2ANSI (t);

              if cmb_from.Text = c_enc_oem then
                 x := IBM2ANSI (t);

              if cmb_from.Text = c_enc_utf8 then
                 x := UTF8ToANSI (t);

              if cmb_to.Text = c_enc_ansi then
                 t := x;

              if cmb_to.Text = c_enc_koi8r then
                 t := ansi2KOI (x);

              if cmb_to.Text = c_enc_koi8u then
                 t := ANSI2KOI8U (x);

              if cmb_to.Text = c_enc_oem then
                 t := ANSI2IBM (x);

              if cmb_to.Text = c_enc_utf8 then
                 t := AnsiToUtf8 (x);

              StringToFile (filename, t);

              ProgressBar1.StepBy (round (GetPercent (list.Count , i)));
         end;

    ProgressBar1.position := 0;
    list.free;
end;

end.
