unit u_fm_find_in_files;

{
 TEA   
  
       (public domain)
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Mask, JvExMask, JvToolEdit, JvComponentBase,
  JvSearchFiles, ComCtrls, JvExControls, JvComponent;

type
  Tfm_find_in_files = class(TForm)
    Panel1: TPanel;
    pan_status: TPanel;
    lb_files: TListBox;
    l_text_to_find: TLabel;
    ed_text_to_find: TEdit;
    l_directory: TLabel;
    ed_directory: TJvDirectoryEdit;
    l_file_mask: TLabel;
    ed_file_mask: TEdit;
    tb_search: TButton;
    JvSearchFiles1: TJvSearchFiles;
    bt_save_as_session: TButton;
    bt_copy_to_clipboard: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tb_searchClick(Sender: TObject);
    procedure lb_filesDblClick(Sender: TObject);
    procedure bt_save_as_sessionClick(Sender: TObject);
    procedure bt_copy_to_clipboardClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }


  end;

var
  fm_find_in_files: Tfm_find_in_files;

implementation

{$R *.dfm}


uses jclStrings, u_strings, u_globals,
     u_charset, u_form_main, u_settings,
     clipbrd;

procedure Tfm_find_in_files.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     action := caFree;
end;

procedure Tfm_find_in_files.tb_searchClick(Sender: TObject);
var
   c, i: integer;
   buf, s: string;
   position: integer;
begin
     if ed_file_mask.Text = '' then
        exit;

     JvSearchFiles1.RootDirectory := ed_directory.Text;
     JvSearchFiles1.FileParams.FileMasks.Text := ed_file_mask.Text;

     lb_files.Items.Clear;

     pan_status.Caption := '  .';
     JvSearchFiles1.Search;
     pan_status.Caption := '     .';

     c := JvSearchFiles1.Files.Count - 1;
     if c = -1 then
        exit;

     for i := 0 to c do
         begin
              buf := FileToString (JvSearchFiles1.Files[i]);
              position := pos (ed_text_to_find.Text, buf);

              if position <> 0 then
                 begin
                      lb_files.AddItem (JvSearchFiles1.Files[i] + ',' + c_enc_ansi + ',' + IntToStr (position), nil);
                      next;
                 end;

              s := KOI2ANSI (ed_text_to_find.Text);
              position := pos (s, buf);

              if position <> 0 then
                 begin
                      lb_files.AddItem (JvSearchFiles1.Files[i]  + ',' +  c_enc_koi8r  + ',' +  IntToStr (position), nil);
                      next;
                 end;

              s := IBM2ANSI (ed_text_to_find.Text);
              position := pos (s, buf);

              if position <> 0 then
                 begin
                      lb_files.AddItem (JvSearchFiles1.Files[i]  + ',' +  c_enc_oem  + ',' +  IntToStr (position), nil);
                      next;
                 end;
         end;

      pan_status.Caption := Format('( %d )', [lb_files.Items.Count]);
end;


procedure Tfm_find_in_files.lb_filesDblClick(Sender: TObject);
begin
     if lb_files.Items.Count = 0 then
        exit;

     fm_main.open_recent (lb_files.Items [lb_files.itemindex]);
end;


procedure Tfm_find_in_files.bt_save_as_sessionClick(Sender: TObject);
var
   s: string;
begin
     s := fm_main.dlg_file_save.InitialDir;
     fm_main.dlg_file_save.InitialDir := settings.dir_sessions;

     if not fm_main.dlg_file_save.Execute then
        begin
             fm_main.dlg_file_save.InitialDir := s;
             exit;
        end;

     lb_files.items.SaveToFile (fm_main.dlg_file_save.filename);
     fm_main.dlg_file_save.InitialDir := s;
     fm_main.update_sessions;
end;


procedure Tfm_find_in_files.bt_copy_to_clipboardClick(Sender: TObject);
begin
     clipboard.AsText := lb_files.items.text;
end;


end.
