unit u_fm_sci_child;

{
 TEA   
  
       (public domain)
}


interface

uses
  Windows, Messages, ComCtrls, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SciLexer, SciLexerMemo, SciLexerMod, JvComponentBase, JvDragDrop,
  Menus, SciAutoComplete, SciCallTips;

type
  Tfm_sci_child = class(TForm)
    Scintilla1: TScintilla;
    JvDragDrop1: TJvDragDrop;
    PopupMenu1: TPopupMenu;
    mni_copy: TMenuItem;
    mni_cut: TMenuItem;
    mni_paste: TMenuItem;
    N4: TMenuItem;
    mni_select_all: TMenuItem;
    SciAutoComplete1: TSciAutoComplete;
    procedure Scintilla1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure JvDragDrop1Drop(Sender: TObject; Pos: TPoint;
      Value: TStrings);
    procedure mni_copyClick(Sender: TObject);
    procedure mni_cutClick(Sender: TObject);
    procedure mni_pasteClick(Sender: TObject);
    procedure mni_select_allClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Scintilla1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    tab: TTabSheet;
  end;

var
  fm_sci_child: Tfm_sci_child;

implementation

{$R *.dfm}

uses
     u_vk, jclstrings,
     u_globals, u_form_main,
     u_settings, clipbrd;


procedure Tfm_sci_child.Scintilla1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if ssCtrl in Shift then
        case key of

             cVK_Up: if Scintilla1.SelLength <> 0 then
                        begin
                             if Scintilla1.CodePage = cpUTF8 then
                                 Scintilla1.SelText :=  UTF8Encode(wideUpperCase (UTF8Decode (Scintilla1.SelText)))
                             else
                           //      Scintilla1.SelText := jclstrings.StrUpper(Scintilla1.SelText);
                                 Scintilla1.SelText := AnsiUpperCase (Scintilla1.SelText);
                                 key := 0;
                         end;

             cVK_Down: if Scintilla1.SelLength <> 0 then
                          begin
                               if Scintilla1.CodePage = cpUTF8 then
                                  Scintilla1.SelText := UTF8Encode(wideLowerCase (UTF8Decode (Scintilla1.SelText)))
                               else
//                                   Scintilla1.SelText := jclstrings.StrLower(Scintilla1.SelText);
                                   Scintilla1.SelText := AnsiLowerCase (Scintilla1.SelText);
                                key:=0;
                           end;

             vk_SPACE: if (ssShift in Shift) then
                          begin
                               Scintilla1.SelText := '&nbsp;';
                               key := 0;
                          end;

             cVK_Return: begin
                              if def_markup_mode = c_mm_xhtml then
                                 Scintilla1.SelText := '<br />'
                              else
                                  Scintilla1.SelText := '<br>';
                              key := 0;
                         end;
       end;
end;


procedure Tfm_sci_child.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     Action := caFree;
     get_current_editor;
     current_editor.Free;
end;


procedure Tfm_sci_child.JvDragDrop1Drop(Sender: TObject; Pos: TPoint;
  Value: TStrings);
var
   i, c: integer;
begin
     c := Value.Count - 1;
     for i := 0 to c do
         file_open (value[i]);
end;


procedure Tfm_sci_child.mni_copyClick(Sender: TObject);
begin
     Scintilla1.Copy;
end;


procedure Tfm_sci_child.mni_cutClick(Sender: TObject);
begin
     Scintilla1.Cut;
end;

 
procedure Tfm_sci_child.mni_pasteClick(Sender: TObject);
begin
     Scintilla1.Paste;
end;


procedure Tfm_sci_child.mni_select_allClick(Sender: TObject);
begin
     fm_sci_child.Scintilla1.SelectAll;
end;


procedure Tfm_sci_child.FormCreate(Sender: TObject);
begin
     SciAutoComplete1.WordCharacters := c_cp1251_rus + '_abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-';
     Scintilla1.WordChars := SciAutoComplete1.WordCharacters;
//     SciCallTips1.WordCharacters := SciAutoComplete1.WordCharacters;
    // SciPropertyLoader1.LoadStyles (settings.color_styles_file);
//     fm_main.SciPropertyLoader1.Editor := Scintilla1;
end;

procedure Tfm_sci_child.FormActivate(Sender: TObject);
begin
     if tab <> nil then
        tab.PageControl.ActivePage := tab;
end;

procedure Tfm_sci_child.Scintilla1KeyPress(Sender: TObject; var Key: Char);
begin
     if settings.sounds_on then
        begin
             if key = #13 then
               fm_main.JvWavePlayer_return.Play
             else
                 fm_main.JvWavePlayer_click.Play;
        end;
end;

end.
