unit u_form_preferences;

{
 TEA   
  
       (public domain)
}


interface

uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls,
  Buttons, JvExControls, JvComponent,
  Mask, JvSpin, tcFontCombobox, JvExExtCtrls,
  JvExMask, JvColorBox, JvColorButton;

type
  Tfm_preferences = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    ts_view: TTabSheet;
    ts_behavior: TTabSheet;
    ts_keyboard: TTabSheet;
    tvMenuItems: TTreeView;
    hkCurrentHotKey: THotKey;
    bt_assign_shortcut: TButton;
    bt_delete_shortcut: TButton;
    cb_eoautoindent: TCheckBox;
    cb_eoTabIndent: TCheckBox;
    gb_font: TGroupBox;
    l_editor_font: TLabel;
    l_font_size: TLabel;
    se_font_size: TJvSpinEdit;
    l_font_color: TLabel;
    gb_right_margin: TGroupBox;
    l_right_margin: TLabel;
    se_right_edge: TJvSpinEdit;
    l_right_edge_color: TLabel;
    gb_colors: TGroupBox;
    l_bg_color: TLabel;
    l_active_line_color: TLabel;
    l_selected_color_bg: TLabel;
    l_selected_color_fg: TLabel;
    gb_switchers: TGroupBox;
    cb_ShowLineNumbers: TCheckBox;
    cb_eoShowSpecialChars: TCheckBox;
    cb_word_wrap: TCheckBox;
    cb_word_wrap_glyph_visible: TCheckBox;
    gb_editor_other: TGroupBox;
    l_tab_width: TLabel;
    se_tab_width: TJvSpinEdit;
    ts_common: TTabSheet;
    cb_autorun: TCheckBox;
    cb_minimize_on_start: TCheckBox;
    l_recent_items_limit: TLabel;
    se_recent_items_limit: TJvSpinEdit;
    cb_restore_last_session: TCheckBox;
    cb_right_switch: TCheckBox;
    cb_exit_on_esc: TCheckBox;
    cb_alpha: TCheckBox;
    bt_apply: TButton;
    bt_close: TButton;
    cb_show_in_tray: TCheckBox;
    cb_add_ext_on_save: TCheckBox;
    ed_ext_on_save: TEdit;
    cb_confirm_mod_save: TCheckBox;
    cb_def_utf8: TCheckBox;
    cb_autoclose_braces: TCheckBox;
    cb_autoclose_quotes: TCheckBox;
    cb_right_edge_visible: TCheckBox;
    cb_editor_font: TtcFontCombobox;
    bt_font_color: TJvColorButton;
    bt_bg_color: TJvColorButton;
    bt_active_line_color: TJvColorButton;
    bt_selected_color_bg: TJvColorButton;
    bt_selected_color_fg: TJvColorButton;
    bt_right_edge_color: TJvColorButton;
    cb_braces_hl: TCheckBox;
    ts_print: TTabSheet;
    gb_margins: TGroupBox;
    l_prn_margin_top: TLabel;
    se_prn_margin_top: TJvSpinEdit;
    se_prn_margin_bottom: TJvSpinEdit;
    l_prn_margin_bottom: TLabel;
    l_prn_margin_left: TLabel;
    l_prn_margin_right: TLabel;
    se_prn_margin_left: TJvSpinEdit;
    se_prn_margin_right: TJvSpinEdit;
    gb_print_range: TGroupBox;
    se_prn_to_page: TJvSpinEdit;
    se_prn_from_page: TJvSpinEdit;
    l_prn_from_page: TLabel;
    l_prn_to_page: TLabel;
    cb_prn_print_range: TCheckBox;
    gb_prn_common: TGroupBox;
    cb_prn_print_page_nums: TCheckBox;
    cb_prn_blackwhite: TCheckBox;
    cb_folding: TCheckBox;
    cb_show_crapbook_on_start: TCheckBox;
    cb_auto_comp: TCheckBox;
    l_caret_color: TLabel;
    bt_caret_color: TJvColorButton;
    cb_hl_under_cursor: TCheckBox;
    cb_show_word_wraps: TCheckBox;
    cb_auto_comp_ignore_case: TCheckBox;
    cb_show_wspaces: TCheckBox;
    cb_sounds_on: TCheckBox;
    procedure bt_assign_shortcutClick(Sender: TObject);
    procedure bt_delete_shortcutClick(Sender: TObject);
    procedure tvMenuItemsClick(Sender: TObject);
    procedure ts_keyboardShow(Sender: TObject);
    procedure bt_closeClick(Sender: TObject);
    procedure bt_applyClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
   fm_preferences: Tfm_preferences;

implementation

{$R *.dfm}

uses
    u_menuskeys, u_form_main, u_settings, u_globals,
    menus;

procedure Tfm_preferences.bt_assign_shortcutClick (Sender: TObject);
var
    tm, t: TMenuItem;
    tn: TTReeNode;
    cp: string;
begin
     tn := tvMenuItems.Selected;

     if tn = nil then
        exit;

     tm := FindMenuItemByCaption (tn.text, fm_main.mainmenu1);

     if tm <> nil then
        begin
             if tm.Count <> 0 then
                begin
                     ShowMessage(' !');
                     exit;
                end;

             t := FindMenuItemByShortcut (hkCurrentHotKey.HotKey, fm_main.mainmenu1);

             if t = nil then
                begin
                     tm.shortcut := hkCurrentHotKey.HotKey;
                     fm_main.SaveShortCuts;
                end
             else
                 if MessageDlg('       ' + t.caption + #13#10 +
                               '?', mtWarning, [mbYes, mbNo], 0) = mrYes then
                    begin
                         cp := t.caption;
                         t:= FindMenuItemByCaption (cp, fm_main.mainmenu1);
                         t.shortcut := Low (Word);
                         tm.shortcut := hkCurrentHotKey.HotKey;
                         fm_main.SaveShortCuts;
                    end
        end
end;


procedure Tfm_preferences.bt_delete_shortcutClick(Sender: TObject);
var
   tm: TMenuItem;
   tn: TTReeNode;
begin
     tn := tvMenuItems.Selected;

     if tn = nil then
        exit;

     tm := FindMenuItemByCaption(tn.text,fm_main.mainmenu1);

     if tm <> nil then
        begin
            tm.shortcut := low (word);
            hkCurrentHotKey.HotKey := tm.shortcut;
            fm_main.SaveShortCuts;
        end;
end;


procedure Tfm_preferences.tvMenuItemsClick(Sender: TObject);
var
   tm:TMenuItem;
   tn:TTReeNode;
begin
     tn := tvMenuItems.Selected;
     if tn = nil then
        exit;

     tm := FindMenuItemByCaption (tn.text, fm_main.mainmenu1);

     if tm <> nil then
        hkCurrentHotKey.HotKey := tm.shortcut;
end;


procedure Tfm_preferences.ts_keyboardShow(Sender: TObject);
begin
      Menu2VTstd (tvMenuItems, fm_main.mainmenu1.items);
end;


procedure Tfm_preferences.bt_closeClick(Sender: TObject);
begin
     close;
end;

procedure Tfm_preferences.bt_applyClick(Sender: TObject);
begin

     settings.sounds_on := cb_sounds_on.checked;
     settings.recent_items_limit := round (se_recent_items_limit.value);
     settings.font_name := cb_editor_font.FontName;

     settings.show_wspaces:= cb_show_wspaces.Checked;
     settings.caret_color := bt_caret_color.Color;
     settings.font_color := bt_font_color.Color;
     settings.bg_color := bt_bg_color.Color;
     settings.font_size := round (se_font_size.Value);
     settings.ShowLineNumbers := cb_ShowLineNumbers.Checked;
     settings.active_line_color := bt_active_line_color.Color;
     settings.right_edge := round (se_right_edge.Value);
     settings.right_edge_color := bt_right_edge_color.Color;
     settings.eoautoindent := cb_eoautoindent.Checked;
     settings.eoTabIndent := cb_eoTabIndent.Checked;
     settings.selected_color_bg := bt_selected_color_bg.Color;
     settings.selected_color_fg := bt_selected_color_fg.Color;
     settings.tab_width := round (se_tab_width.Value);
     settings.word_wrap := cb_word_wrap.Checked;
     settings.word_wrap_glyph_visible := cb_word_wrap_glyph_visible.Checked;
     settings.right_switch := cb_right_switch.Checked;
     settings.autorun := cb_autorun.checked;
     settings.show_in_tray := cb_show_in_tray.checked;

     settings.confirm_mod_save := cb_confirm_mod_save.Checked;
     settings.auto_comp := cb_auto_comp.Checked;

     settings.show_wraps := cb_show_word_wraps.Checked;

     settings.braces_hl := cb_braces_hl.checked;
     settings.folding := cb_folding.checked;
     settings.right_edge_visible := cb_right_edge_visible.Checked;

     settings.add_ext_on_save := cb_add_ext_on_save.Checked;
     settings.ext_on_save := ed_ext_on_save.Text;
     settings.def_utf8 := cb_def_utf8.checked;

     settings.hl_under_cursor := cb_hl_under_cursor.Checked;

     settings.autorun := cb_autorun.checked;
     settings.alpha := cb_alpha.Checked;
     settings.restore_last_session := cb_restore_last_session.Checked;
     settings.exit_on_esc := cb_exit_on_esc.Checked;
     settings.minimize_on_start := cb_minimize_on_start.Checked;

     settings.show_crapbook_on_start := cb_show_crapbook_on_start.Checked;

     settings.autoclose_braces := cb_autoclose_braces.Checked;
     settings.autoclose_quotes := cb_autoclose_quotes.Checked;

     settings.prn_print_page_nums := cb_prn_print_page_nums.Checked;
     settings.prn_blackwhite := cb_prn_blackwhite.Checked;

     settings.prn_print_range := cb_prn_print_range.Checked;
     settings.prn_from_page := round (se_prn_from_page.Value);
     settings.prn_to_page := round (se_prn_to_page.Value);

     settings.prn_margin_top := round (se_prn_margin_top.Value);
     settings.prn_margin_bottom := round (se_prn_margin_bottom.Value);
     settings.prn_margin_left := round (se_prn_margin_left.Value);
     settings.prn_margin_right := round (se_prn_margin_right.Value);

     settings.auto_comp_ignore_case := cb_auto_comp_ignore_case.Checked;

     settings.save;
     fm_main.update_settings;
end;


procedure Tfm_preferences.FormCreate(Sender: TObject);
begin
     se_recent_items_limit.value := settings.recent_items_limit;
     cb_right_edge_visible.Checked := settings.right_edge_visible;
     cb_def_utf8.checked := settings.def_utf8;
     cb_autoclose_braces.Checked := settings.autoclose_braces;
     cb_autoclose_quotes.Checked := settings.autoclose_quotes;
     cb_folding.checked := settings.folding;

     cb_auto_comp_ignore_case.Checked := settings.auto_comp_ignore_case;
     cb_autorun.checked := settings.autorun;
     cb_alpha.Checked := settings.alpha;
     cb_restore_last_session.Checked := settings.restore_last_session;
     cb_confirm_mod_save.Checked := settings.confirm_mod_save;
     cb_editor_font.FontName := settings.font_name;
     bt_font_color.Color := settings.font_color;
     bt_bg_color.Color := settings.bg_color;
     se_font_size.Value := settings.font_size;
     cb_ShowLineNumbers.Checked := settings.ShowLineNumbers;
     bt_active_line_color.Color := settings.active_line_color;
     se_right_edge.Value := settings.right_edge;
     bt_right_edge_color.Color := settings.right_edge_color;
     cb_eoautoindent.Checked := settings.eoautoindent;
     cb_eoTabIndent.Checked := settings.eoTabIndent;
     bt_selected_color_bg.Color := settings.selected_color_bg;
     bt_selected_color_fg.Color := settings.selected_color_fg;
     se_tab_width.Value := settings.tab_width;
     cb_word_wrap.Checked := settings.word_wrap;
     cb_word_wrap_glyph_visible.Checked := settings.word_wrap_glyph_visible;
     cb_braces_hl.checked := settings.braces_hl;
     cb_show_word_wraps.Checked := settings.show_wraps;

     cb_show_wspaces.Checked := settings.show_wspaces;

     cb_sounds_on.checked := settings.sounds_on;

     cb_show_in_tray.checked := settings.show_in_tray;
     cb_minimize_on_start.Checked := settings.minimize_on_start;
     cb_add_ext_on_save.Checked := settings.add_ext_on_save;
     ed_ext_on_save.Text := settings.ext_on_save;

     cb_hl_under_cursor.Checked := settings.hl_under_cursor;

     cb_exit_on_esc.Checked := settings.exit_on_esc;
     cb_right_switch.Checked := settings.right_switch;

     cb_prn_print_page_nums.Checked := settings.prn_print_page_nums;
     cb_prn_blackwhite.Checked := settings.prn_blackwhite;

     cb_prn_print_range.Checked := settings.prn_print_range;
     se_prn_from_page.Value := settings.prn_from_page;
     se_prn_to_page.Value := settings.prn_to_page;

     se_prn_margin_top.Value := settings.prn_margin_top;
     se_prn_margin_bottom.Value := settings.prn_margin_bottom;
     se_prn_margin_left.Value := settings.prn_margin_left;
     se_prn_margin_right.Value := settings.prn_margin_right;

     cb_show_crapbook_on_start.Checked := settings.show_crapbook_on_start;
     cb_auto_comp.Checked := settings.auto_comp;

     bt_caret_color.Color := settings.caret_color;

     PageControl1.ActivePageIndex := last_prefs_page;
end;


procedure Tfm_preferences.PageControl1Change(Sender: TObject);
begin
     last_prefs_page := PageControl1.ActivePageIndex;
end;


end.
