unit u_gui_utils;

{
 TEA   
  
}

interface

uses menus, classes, StdCtrls, ExtCtrls, types;


procedure BuildMenuFromList (list: TStrings; menu: TMenuItem; callback: TNotifyEvent);
function GetListBoxItem (lb: TListBox): string;
procedure SetComboBoxCaption (lb: TComboBox; s: string);
procedure SetListBoxCaption (lb: TListBox; s: string);
procedure UncheckAllMenuItems (m: TMenuItem);
procedure BuildNamesMenuFromList (list: TStrings; menu: TMenuItem; callback: TNotifyEvent);


implementation


procedure BuildMenuFromList (list: TStrings; menu: TMenuItem; callback: TNotifyEvent);
var
   c, i: integer;
   m: TMenuItem;
begin
     menu.Clear;
     c := list.Count - 1;
     for i := 0 to c do
         begin
              m := TMenuItem.Create (menu);
              m.Caption := list [i];
              m.OnClick := callback;
              menu.Add(m);
         end;
end;


procedure BuildNamesMenuFromList (list: TStrings; menu: TMenuItem; callback: TNotifyEvent);
var
   c, i: integer;
   m: TMenuItem;
begin
     menu.Clear;
     c := list.Count - 1;
     for i := 0 to c do
         begin
              m := TMenuItem.Create (menu);
              m.Caption := list.Names[i];
              m.OnClick := callback;
              menu.Add(m);
         end;
end;


function GetListBoxItem (lb: TListBox): string;
begin
     result := '';
     if lb.itemindex <> -1 then
        result := lb.items[lb.itemindex];
end;


procedure SetComboBoxCaption (lb: TComboBox; s: string);
var
   i: integer;
begin
     i := lb.items.indexof (s);
     if i = -1 then
        exit;
     lb.itemindex := i;
end;


procedure SetListBoxCaption (lb: TListBox; s: string);
var
   i: integer;
begin
     i := lb.items.indexof (s);
     if i = -1 then
        exit;
     lb.itemindex := i;
end;


procedure UncheckAllMenuItems (m: TMenuItem);
var i: integer;
begin
     for i := 0 to m.Count - 1 do
         m.Items[i].Checked := FALSE;
end;


end.
