unit u_menuskeys;

{
 TEA   
  
       (public domain)
}


interface

uses
     menus, ComCtrls, Classes;

function FindMenuItemByCaption(caption:string;mn:TMainMenu):TMenuItem;overload;
function FindMenuItemByCaption(caption:string;mn:TMenuItem):TMenuItem;overload;
function FindMenuItemByShortcut(Shortcut:tShortCut;mn:TMainMenu):TMenuItem;
function FindMenuItemByName(name:string;mn:TMainMenu):TMenuItem;overload;
function FindMenuItemByName(name:string;mn:TMenuItem):TMenuItem;overload;
function GetShortcutsTree(mi:TMenuItem):string;

procedure Menu2VTstd(vt:TTreeView;mi:TMenuItem);


implementation


procedure Menu2VTstd (vt: TTreeView; mi: TMenuItem);
var
   i: integer;
   fnd: TTreeNode;

procedure InDeep (m: TmenuItem; ParentNode: TTreeNode);
var
   i, c: integer;
   Node: TTreeNode;
begin
     Node := vt.Items.AddChild (ParentNode, m.Caption);
     c := m.count;

     if c <> 0 then
        begin
             c := c - 1;
             for i := 0 to c do
                 InDeep (m.items[i], Node)
         end;
end;

begin
     vt.Items.BeginUpdate;
     vt.items.clear;
     fnd := nil;

     for i := 0 to mi.count - 1 do
         InDeep (mi[i], fnd);

     vt.Items.EndUpdate;
end;



function FindMenuItemByShortcut (Shortcut: TShortCut; mn: TMainMenu): TMenuItem;
var
   i: integer;

procedure InDeep (m: TmenuItem);
var
   i, c: integer;
begin
     if Shortcut = m.Shortcut then
        begin
             result := m;
             exit;
        end;

     c := m.count-1;

     if c <> -1 then
       for i := 0 to c do
           InDeep (m.items[i]);
end;

begin
     result := nil;

     for i := 0 to mn.items.count - 1 do
         begin
              InDeep (mn.items[i]);
              if result <> nil then
                 break;
         end;
end;


function FindMenuItemByCaption (caption: string; mn: TMainMenu): TMenuItem;
var
   i: integer;

procedure InDeep (m: TmenuItem);
var
   i, c: integer;
begin
    if caption = m.caption then
       begin
            result := m;
            exit;
       end;

    c := m.count;

    if c <> 0 then
       begin
            c := c - 1;
            for i := 0 to c do
                InDeep (m.items[i]);
       end;
end;

begin
     result := nil;
     for i := 0 to mn.items.count - 1 do
         InDeep (mn.items[i]);
end;


function FindMenuItemByCaption (caption: string; mn: TMenuItem): TMenuItem;
var
   i:integer;

procedure InDeep (m: TmenuItem);
var
   i, c: integer;
begin
     if caption = m.caption then
       begin
            result := m;
            exit;
       end;

     c := m.count;

     if c <> 0 then
        begin
             c := c - 1;
             for i := 0 to c do
                 InDeep (m.items[i]);
       end;
end;

begin
     result := nil;
     for i := 0 to mn.count - 1 do
         InDeep (mn.items[i]);
end;


function FindMenuItemByName (Name: string; mn: TMainMenu): TMenuItem;
var i:integer;

procedure InDeep(m:TMenuItem);
var
   i, c: integer;
begin
     if Name = m.Name then
       begin
            result := m;
            exit;
       end;

    c := m.count;

    if c <> 0 then
       begin
            c := c - 1;
            for i := 0 to c do
                InDeep (m.items[i]);
       end;
end;

begin
     result := nil;
     for i := 0 to mn.items.count - 1 do
         InDeep (mn.items[i]);
end;


function FindMenuItemByName (Name: string; mn: TMenuItem): TMenuItem;
var
   i: integer;

procedure InDeep (m: TMenuItem);
var
   i, c: integer;
begin
     if Name = m.Name then
       begin
            result := m;
            exit;
       end;

    c := m.count;
    if c <> 0 then
       begin
            c := c - 1;
            for i := 0 to c do
                InDeep (m.items[i]);
       end;
end;

begin
     result := nil;

     for i := 0 to mn.count - 1 do
         InDeep (mn.items[i]);
end;


function GetParents (mni: TMenuItem; prefix: string): string;
var
    t: TMenuItem;
    s: string;
begin
     s := prefix + mni.caption + ' ------ ' + ShortCutToText (mni.shortcut);
     t := mni.parent;

     while t <> nil do
           begin
                s := prefix + t.caption+s;
                t := t.parent;
           end;

     result := s;
end;


function GetShortcutsTree (mi: TMenuItem): string;
var
   i: integer;
   sl: TStringList;

procedure InDeep (m: TmenuItem);
var
   i, c: integer;
begin
     if m.Shortcut <> 0 then
       begin
            sl.add (GetParents (m, ' > '));
            exit;
       end;

     c := m.count;
     if c <> 0 then
        begin
             c := c-1;
             for i := 0 to c do
                InDeep (m.items[i]);
        end;
end;

begin
     result := '';
     sl := TStringList.create;

     for i := 0 to mi.count - 1 do
         InDeep (mi.items[i]);

     result := sl.text;
     sl.free;
end;


end.
