unit u_settings;


interface

uses classes, IniFiles, forms, u_globals, Graphics;

type

TSettings = class

  ini_file: TIniFile;

  auto_comp: boolean;
  auto_comp_ignore_case: boolean;

  sounds_on: boolean;

  caret_color: TColor;

  dlg_file_open_Width: integer;
  dlg_file_open_height: integer;
  dlg_file_save_Width: integer;
  dlg_file_save_height: integer;

  recent_items_limit: integer;

  prn_print_range: boolean;
  prn_blackwhite: boolean;
  prn_print_page_nums: boolean;

  prn_from_page: integer;
  prn_to_page: integer;

  show_crapbook_on_start: boolean;
  hl_under_cursor: boolean;

  prn_margin_top: integer;
  prn_margin_bottom: integer;
  prn_margin_left: integer;
  prn_margin_right: integer;
  confirm_mod_save: boolean;

  show_wspaces: boolean;


  autorun: boolean;
  add_ext_on_save: boolean;
  ext_on_save: string;

  folding: boolean;
  def_utf8: boolean;

  autoclose_braces: boolean;
  autoclose_quotes: boolean;
  braces_hl: boolean;

  minimize_on_start: boolean;
  alpha: boolean;
  restore_last_session: boolean;
  show_in_tray: boolean;

  color_styles_file: string;
  crapbook_file: string;
  fav_file: string;
  external_file: string;

  temp_file: string;

  dir_tea_install: string;
  dir_multirepl: string;
  dir_snippets: string;
  dir_templates: string;
  dir_temp: string;
  dir_sessions: string;
  dir_user: string;

  right_switch: boolean;
  exit_on_esc: boolean;

  bg_color: Tcolor;
  active_line_color: TColor;
  font_name: string;
  font_color: TColor;
  font_size: integer;

  ShowLineNumbers: boolean;

  eoautoindent: boolean;
  eoTabIndent: boolean;

  gutter: boolean;
  show_wraps: boolean;

  right_edge_visible: boolean;
  right_edge: integer;
  right_edge_color: TColor;
  selected_color_bg: TColor;
  selected_color_fg: TColor;
  tab_width: integer;
  word_wrap: boolean;
  word_wrap_glyph_visible: boolean;

  ms_click: TMemoryStream;
  ms_return: TMemoryStream;

///////////

constructor create;
destructor destroy; override;
procedure save;

end;


var
   settings: TSettings;

implementation

uses SysUtils, JclFileUtils, u_functions;


procedure TSettings.save;
begin
     ini_file.WriteInteger ('Common', 'recent_items_limit', recent_items_limit);
     ini_file.WriteInteger ('Common', 'active_line_color', active_line_color);
     ini_file.WriteInteger ('Common', 'bg_color', bg_color);
     ini_file.WriteString ('Common', 'font_name', font_name);
     ini_file.WriteInteger ('Common', 'font_color', font_color);
     ini_file.WriteInteger ('Common', 'font_size', font_size);
     ini_file.WriteInteger ('Common', 'caret_color', caret_color);

     ini_file.WriteBool ('Common', 'hl_under_cursor', hl_under_cursor);

     ini_file.WriteBool ('Common', 'show_crapbook_on_start', show_crapbook_on_start);
     ini_file.WriteBool ('Common', 'auto_comp', auto_comp);
     ini_file.WriteBool ('Common', 'show_wraps', show_wraps);
     ini_file.WriteBool ('Common', 'show_wspaces', show_wspaces);
                                                             


     ini_file.WriteBool ('Common', 'sounds_on', sounds_on);


     ini_file.WriteBool ('Common', 'braces_hl', braces_hl);
     ini_file.WriteBool ('Common', 'confirm_mod_save', confirm_mod_save);
     ini_file.WriteBool ('Common', 'folding', folding);
     ini_file.WriteBool ('Common', 'right_edge_visible', right_edge_visible);

     ini_file.WriteBool ('Common', 'autoclose_braces', autoclose_braces);
     ini_file.WriteBool ('Common', 'autoclose_quotes', autoclose_quotes);
     ini_file.WriteBool ('Common', 'def_utf8', def_utf8);

     ini_file.WriteBool ('Common', 'add_ext_on_save', add_ext_on_save);
     ini_file.WriteString ('Common', 'ext_on_save', ext_on_save);
     ini_file.WriteBool ('Common', 'show_in_tray', show_in_tray);
     ini_file.WriteBool ('Common', 'autorun', autorun);
     ini_file.WriteBool ('Common', 'restore_last_session', restore_last_session);
     ini_file.WriteBool ('Common', 'auto_comp_ignore_case', auto_comp_ignore_case);

     ini_file.WriteBool ('Common', 'exit_on_esc', exit_on_esc);
     ini_file.WriteBool ('Common', 'right_switch', right_switch);
     ini_file.WriteBool ('Common', 'gutter', gutter);
     ini_file.WriteBool ('Common', 'alpha', alpha);
     ini_file.WriteBool ('Common', 'minimize_on_start', minimize_on_start);

     ini_file.WriteBool ('Common', 'ShowLineNumbers', ShowLineNumbers);
     ini_file.WriteBool ('Common', 'eoAutoIndent', eoAutoIndent);
     ini_file.WriteBool ('Common', 'eoTabIndent', eoTabIndent);
     ini_file.WriteInteger ('Common', 'right_edge', right_edge);
     ini_file.WriteInteger ('Common', 'right_edge_color', right_edge_color);
     ini_file.WriteInteger ('Common', 'selected_color_bg', selected_color_bg);
     ini_file.WriteInteger ('Common', 'selected_color_fg', selected_color_fg);
     ini_file.WriteInteger ('Common', 'tab_width', tab_width);
     ini_file.WriteBool ('Common', 'word_wrap', word_wrap);
     ini_file.WriteBool ('Common', 'word_wrap_glyph_visible', word_wrap_glyph_visible);

     ini_file.WriteBool ('Common', 'prn_print_range', prn_print_range);
     ini_file.WriteBool ('Common', 'prn_blackwhite', prn_blackwhite);
     ini_file.WriteBool ('Common', 'prn_print_page_nums', prn_print_page_nums);

     ini_file.WriteInteger ('Common', 'prn_from_page', prn_from_page);
     ini_file.WriteInteger ('Common', 'prn_to_page', prn_to_page);
     ini_file.WriteInteger ('Common', 'prn_margin_top', prn_margin_top);
     ini_file.WriteInteger ('Common', 'prn_margin_bottom', prn_margin_bottom);
     ini_file.WriteInteger ('Common', 'prn_margin_left', prn_margin_left);
     ini_file.WriteInteger ('Common', 'prn_margin_right', prn_from_page);

     ini_file.WriteInteger ('Common', 'dlg_file_open.Width', dlg_file_open_Width);
     ini_file.WriteInteger ('Common', 'dlg_file_open.height', dlg_file_open_height);
     ini_file.WriteInteger ('Common', 'dlg_file_save.Width', dlg_file_save_Width);
     ini_file.WriteInteger ('Common', 'dlg_file_save.height', dlg_file_save_height);



     ini_file.UpdateFile;
end;


constructor TSettings.create;
begin
     inherited;

     dir_tea_install := ExtractFilePath (application.ExeName);
     dir_user := dir_tea_install + 'user';

     dir_snippets := dir_user + '\snippets';
     dir_templates := dir_user + '\templates';
     dir_temp := PathGetTempPath + 'tea';

     dir_sessions := dir_user + '\sessions';
     dir_multirepl := dir_user + '\multireplace';

     temp_file := PathGetTempPath + 'temp.txt';

     color_styles_file := dir_user + '\color_styles.txt';
     crapbook_file := dir_user + '\scrapbook.txt';
     fav_file := dir_user + '\fav.txt';

     external_file := dir_user + '\external.txt';

     ForceDirectories (dir_user);
     ForceDirectories (dir_snippets);
     ForceDirectories (dir_templates);
     ForceDirectories (dir_temp);
     ForceDirectories (dir_sessions);
     ForceDirectories (dir_multirepl);

     ini_file := TIniFile.Create (dir_user + '\tea.ini');

     dlg_file_open_Width := ini_file.ReadInteger ('Common', 'dlg_file_open.Width', round (GetValue (screen.Width, 75)));
     dlg_file_open_height := ini_file.ReadInteger ('Common', 'dlg_file_open.height', round (GetValue (screen.height, 75)));
     dlg_file_save_Width := ini_file.ReadInteger ('Common', 'dlg_file_save.Width', round (GetValue (screen.Width, 75)));
     dlg_file_save_height := ini_file.ReadInteger ('Common', 'dlg_file_save.height', round (GetValue (screen.height, 75)));


     recent_items_limit := ini_file.ReadInteger ('Common', 'recent_items_limit', 15);
     active_line_color := ini_file.ReadInteger ('Common', 'active_line_color', clWindow);
     bg_color := ini_file.ReadInteger ('Common', 'bg_color', clWindow);
     font_name := ini_file.ReadString ('Common', 'font_name', 'Courier New');
     font_color := ini_file.ReadInteger ('Common', 'font_color', clWindowText);
     caret_color := ini_file.ReadInteger ('Common', 'caret_color', clWindowText);

     font_size := ini_file.ReadInteger ('Common', 'font_size', 10);
     ShowLineNumbers := ini_file.ReadBool ('Common', 'ShowLineNumbers', false);
     eoAutoIndent := ini_file.ReadBool ('Common', 'eoAutoIndent', false);

     right_switch := ini_file.ReadBool ('Common', 'right_switch', true);
     exit_on_esc := ini_file.ReadBool ('Common', 'exit_on_esc', false);
     restore_last_session := ini_file.ReadBool ('Common', 'restore_last_session', false);
     show_wspaces := ini_file.ReadBool ('Common', 'show_wspaces', false);


     autorun := ini_file.ReadBool ('Common', 'autorun', false);
     auto_comp := ini_file.ReadBool ('Common', 'auto_comp', true);

     show_wraps := ini_file.ReadBool ('Common', 'show_wraps', false);
     auto_comp_ignore_case := ini_file.ReadBool ('Common', 'auto_comp_ignore_case', false);

     hl_under_cursor := ini_file.ReadBool ('Common', 'hl_under_cursor', false);

     add_ext_on_save := ini_file.ReadBool ('Common', 'add_ext_on_save', false);
     ext_on_save := ini_file.ReadString ('Common', 'ext_on_save', 'txt');

     gutter := ini_file.ReadBool ('Common', 'gutter', false);
     alpha := ini_file.ReadBool ('Common', 'alpha', false);

     show_crapbook_on_start := ini_file.ReadBool ('Common', 'show_crapbook_on_start', false);
     minimize_on_start := ini_file.ReadBool ('Common', 'minimize_on_start', false);
     show_in_tray := ini_file.ReadBool ('Common', 'show_in_tray', false);
     sounds_on := ini_file.ReadBool ('Common', 'sounds_on', false);

     def_utf8 := ini_file.ReadBool ('Common', 'def_utf8', false);

     autoclose_braces := ini_file.ReadBool ('Common', 'autoclose_braces', false);
     autoclose_quotes := ini_file.ReadBool ('Common', 'autoclose_quotes', false);

     folding := ini_file.ReadBool ('Common', 'folding', false);
     braces_hl := ini_file.ReadBool ('Common', 'braces_hl', true);

     confirm_mod_save := ini_file.ReadBool ('Common', 'confirm_mod_save', true);
     right_edge_visible := ini_file.ReadBool ('Common', 'right_edge_visible', false);
     eoTabIndent := ini_file.ReadBool ('Common', 'eoTabIndent', false);
     right_edge := ini_file.ReadInteger ('Common', 'right_edge', 72);
     right_edge_color := ini_file.ReadInteger ('Common', 'right_edge_color', clWindow);
     selected_color_bg := ini_file.ReadInteger ('Common', 'selected_color_bg', clHighlight);
     selected_color_fg := ini_file.ReadInteger ('Common', 'selected_color_fg', clHighlightText);
     tab_width := ini_file.ReadInteger ('Common', 'tab_width', 8);
     word_wrap := ini_file.ReadBool ('Common', 'word_wrap', true);
     word_wrap_glyph_visible := ini_file.ReadBool ('Common', 'word_wrap_glyph_visible', false);

     prn_print_range := ini_file.ReadBool ('Common', 'prn_print_range', false);
     prn_blackwhite := ini_file.ReadBool ('Common', 'prn_blackwhite', true);
     prn_print_page_nums := ini_file.ReadBool ('Common', 'prn_print_page_nums', false);
     prn_from_page := ini_file.ReadInteger ('Common', 'prn_from_page', 0);
     prn_to_page := ini_file.ReadInteger ('Common', 'prn_to_page', 0);
     prn_margin_top := ini_file.ReadInteger ('Common', 'prn_margin_top', 500);
     prn_margin_bottom := ini_file.ReadInteger ('Common', 'prn_margin_bottom', 500);
     prn_margin_left := ini_file.ReadInteger ('Common', 'prn_margin_left', 500);
     prn_margin_right := ini_file.ReadInteger ('Common', 'prn_margin_right', 500);

     ms_click := TMemoryStream.Create;
     ms_return := TMemoryStream.Create;

     if FileExists (dir_tea_install + 'sounds\click.wav') then
        ms_click.LoadFromFile(dir_tea_install + 'sounds\click.wav');

     if FileExists (dir_tea_install + 'sounds\cr8.wav') then
        ms_return.LoadFromFile(dir_tea_install + 'sounds\cr8.wav');

end;


destructor TSettings.destroy;
begin
     ini_file.Free;
     ms_click.Free;
     ms_return.Free;
     inherited;
end;


end.
