unit u_strings;

{
 TEA   
  
       (public domain)
}

interface

uses classes, jclUnicode, menus;


function str_trim_from_char_right (const text: string; sep: string): string;
function reverse_lines (const text: string): string;
function reverse_lines_w (const text: widestring): widestring;
function str_extract_each_between (const text: string; sep: char): string;
function wide_strings_sort (const text: widestring): widestring;
function NumStrings (const value: string; fs, metachar: string): string;
function NumStrings_w (const value: widestring; fs, metachar: string): widestring;
function delete_emply_lines (const text: string): string;
function IsExt (const filename: string; const ext: string): boolean;
function SwapKeybChars (const s: string): string;
procedure SafeSetString (var s: string; const newval: string);
procedure FillListFromMenu (l: TStrings; mn: TMainMenu);
function IsNumber (const s: string): boolean;
function quick_strings_sort (const sl: TStrings; remove_dups: boolean): TStringList;
function get_line_ending (const s: string): string;
function kill_formatting (const s: string): string;
function CountOfChar (const s :string; ch: Char): Integer;
function delete_emply_lines_w (const text: widestring): widestring;
function element_of_string (const s: string; const delimeter: string; index: integer): string;
function multi_replace_from_list (const text: string; data: TStrings): string;
function multi_replace_from_file (const text, filename: string): string;
function extract_words (const text: string): TStrings;
function build_path (const pathtofile: string; sel: string): string;
function strings_sort_w (const s: widestring): widestring;
function str_apply_template_w (const text: widestring; const template: string): WideString;
function str_apply_template (const text: string; const template: string): string;
function html_to_text_w (const text: widestring): WideString;
function html_to_text (const text: string): string;


implementation

uses
    sysutils, strutils, u_globals, JclStrings,
    forms, u_form_main;


function IsExt (const filename: string; const ext: string): boolean;
begin
     result := (ANSILowerCase (extractFileExt (filename)) = ANSILowerCase (ext));
end;


function SwapKeybChar (c: char): char;
begin
     result := c;

     case c of

     'q': result := '';
     'w': result := '';
     'e': result := '';
     'r': result := '';
     't': result := '';
     'y': result := '';
     'u': result := '';
     'i': result := '';
     'o': result := '';
     'p': result := '';
     '[': result := '';
     ']': result := '';
     'a': result := '';
     's': result := '';
     'd': result := '';
     'f': result := '';
     'g': result := '';
     'h': result := '';
     'j': result := '';
     'k': result := '';
     'l': result := '';
     ';': result := '';
     #39: result := '';
     //////////////////

     'z': result := '';
     'x': result := '';
     'c': result := '';
     'v': result := '';
     'b': result := '';
     'n': result := '';
     'm': result := '';
     ',': result := '';
     '.': result := '';
     '/': result := '.';
     'Q': result := '';
     'W': result := '';
     'E': result := '';
     'R': result := '';
     'T': result := '';
     'Y': result := '';
     'U': result := '';
     'I': result := '';
     'O': result := '';
     'P': result := '';
     '{': result := '';
     '}': result := '';

      /////////////////

     'A': result := '';
     'S': result := '';
     'D': result := '';
     'F': result := '';
     'G': result := '';
     'H': result := '';
     'J': result := '';
     'K': result := '';
     'L': result := '';
     ':': result := '';
     '"': result := '';
     'Z': result := '';
     'X': result := '';
     'C': result := '';
     'V': result := '';
     'B': result := '';
     'N': result := '';
     'M': result := '';
     '<': result := '';
     '>': result := '';

      ////////////////
     '': result := 'q';
     '': result := 'w';
     '': result := 'e';
     '': result := 'r';
     '': result := 't';
     '': result := 'y';
     '': result := 'u';
     '': result := 'i';
     '': result := 'o';
     '': result := 'p';
     '': result := '[';
     '': result := ']';
     '': result := 'a';
     '': result := 's';
     '': result := 'd';
     '': result := 'f';
     '': result := 'g';
     '': result := 'h';
     '': result := 'j';
     '': result := 'k';
     '': result := 'l';
     '': result := ';';
     '': result := #39;
     '': result := 'z';
     '': result := 'x';
     '': result := 'c';
     '': result := 'v';
     '': result := 'b';
     '': result := 'n';
     '': result := 'm';
     '': result := ',';
     '': result := '.';
//     '.': result:='/';
     '': result := 'Q';
     '': result := 'W';
     '': result := 'E';
     '': result := 'R';
     '': result := 'T';
     '': result := 'Y';
     '': result := 'U';
     '': result := 'I';
     '': result := 'O';
     '': result := 'P';
     '': result := '{';
     '': result := '}';
     '': result := 'A';
     '': result := 'S';
     '': result := 'D';
     '': result := 'F';
     '': result := 'G';
     '': result := 'H';
     '': result := 'J';
     '': result := 'K';
     '': result := 'L';
     '': result := ':';
     '': result := '"';
     '': result := 'Z';
     '': result := 'X';
     '': result := 'C';
     '': result := 'V';
     '': result := 'B';
     '': result := 'N';
     '': result := 'M';
     '': result := '<';
     '': result := '>';
  end;

end;


function SwapKeybChars (const s: string): string;
var
   i, l: integer;
begin
     result := s;
     l := Length (result);
     for i := 1 to l do
         result[i] := SwapKeybChar (s[i]);
end;


procedure SafeSetString (var s: string; const newval: string);
begin
     if newval <> '' then
        s := newval;
end;

procedure FillListFromMenu (l: TStrings; mn: TMainMenu);
var
   i: integer;

procedure InDeep (m: TmenuItem);
var
   i, c: integer;
begin
     c := m.count;
     L.add (m.caption);
     if c <> 0 then
       begin
            c := c - 1;
            for i := 0 to c
                do InDeep (m.items[i]);
       end
end;

begin
     l.clear;
     for i := 0 to mn.items.count - 1 do
         InDeep (mn.items[i]);
end;


function IsNumber (const s: string): boolean;
var
   i, l: integer;
begin
     result := FALSE;
     l := length (s);

     for i := 1 to l do
         if not (s[i] in ['0'..'9']) then
            exit;

     result := true;
end;


function quick_strings_sort (const sl:TStrings; remove_dups: boolean): TStringList;
var
    a_s: array [0..255] of TStrings;
    i, j, c: integer;
    t: string;
    tsl: TStringList;
begin
     c := sl.count-1;
     if c = -1 then
        begin
             result := nil;
             exit;
        end;

     fm_main.log_to_memo (' ');

     for i := 0 to 255 do
         a_s[i] := TStringList.Create;

     fm_main.log_to_memo (' ');

     for i := 0 to c do
         if sl[i] <> '' then
            begin
                 a_s[byte(sl[i][1])].add (sl[i]);
                 fm_main.sb_main.panels[c_cb_ext].text := intTostr (i);
                 application.handlemessage;
            end;

    fm_main.log_to_memo ('');

    for i := 0 to 255 do
        begin
             c := a_s[i].count - 1;
             if c = -1 then continue;

             c := c - 1;

             for j := 0 to c do
                 if a_s[i][j] < a_s[i][j + 1] then
                    begin
                         t := a_s[i][j];
                         a_s[i][j] := a_s[i][j + 1];
                         a_s[i][j+1] := t;

                         fm_main.log_to_memo (intTostr (i) + ' ' + intTostr (j));
                         application.handlemessage;
                    end;
        end;

     if remove_dups then
        fm_main.log_to_memo(' ');

     application.handlemessage;

     if remove_dups then
        for i := 0 to 255 do
            begin
                 c := a_s[i].count - 1;
                 if c = -1 then
                    continue;

                 fm_main.sb_main.panels[c_cb_ext].Text := intTostr (i);
                 application.handlemessage;

                 tsl:=TStringList.create;
                 tsl.Duplicates:=dupIgnore;
                 tsl.sorted:=true;

                 for j := 0 to c do
                     tsl.add (a_s[i][j]);

                 a_s[i].clear;
                 a_s[i].assign (tsl);

                tsl.free;
            end;

     result := TStringList.Create;

     fm_main.log_to_memo (' -');
     application.handlemessage;

     for i := 0 to 255 do
         begin
              result.addstrings (a_s[i]);
              fm_main.sb_main.panels[c_cb_ext].Text := (intTostr (i));
              application.handlemessage;
              a_s[i].free;
         end;
end;


function str_apply_template (const text: string; const template: string): string;
var
   sl: TStringList;
   i, c: integer;
begin
     sl := TStringList.Create;
     sl.Text := text;
     c := sl.Count - 1;
     for i := 0 to c do
         sl[i] := ANSIReplaceStr (template, '%s', sl[i]);

     result := sl.Text;
     sl.Free;
end;


function str_apply_template_w (const text: widestring; const template: string): WideString;
var
   sl: TWideStringList;
   i, c: integer;
begin
     sl := TWideStringList.Create;
     sl.Text := text;
     c := sl.Count - 1;
     for i := 0 to c do
         sl[i] := ANSIReplaceText (template, '%s', sl[i]);

     result := sl.Text;
     sl.Free;
end;


function get_line_ending (const s: string): string;
begin
     if AnsiContainsStr (s, #13#10) then
        result := c_le_crlf
     else
         result := c_le_lf;
end;


function kill_formatting (const s: string): string;
var
   i, c: integer;
begin
     result := '';
     c := length (s);

     for i := 1 to c do
         begin
              if not CharIsWhiteSpace (s[i]) then
                 result := result + s[i]
               else
                   if (s[i] = ' ') and (not CharIsWhiteSpace (s[i + 1])) then
                      result := result + s[i];
         end;
end;


function CountOfChar (const s :string; ch: Char): Integer;
var
   i, c: Integer;
begin
     result := 0;
     c := length (s);
     for i := 1 to c do
        if s[i] = Ch then
           result := result + 1;
end;


function element_of_string (const s: string; const delimeter: string; index: integer): string;
var
   list: TStrings;
begin
     list := TStringList.Create;
     StrToStrings (s, delimeter, list, FALSE);

     if index > (list.Count - 1) then
        result := ''
     else
         result := list [index];

     list.Free;
end;



function multi_replace_from_list (const text: string; data: TStrings): string;
var
   i: integer;
   find_what, replace_to: string;
begin
     if data.count = 0 then
        begin
             result := '';
             exit;
         end;

     result := text;

     for i := 0 to data.count - 1 do
         begin
              find_what := element_of_string (data[i], '=', 0);
              replace_to := element_of_string (data[i], '=', 1);
              if (find_what <> '') and (replace_to <> '') then
                 StrReplace (result, find_what, replace_to, [rfReplaceAll]);
         end;
end;


function multi_replace_from_file (const text, filename: string): string;
var
   sl: TStringList;
begin
     sl := TStringList.Create;
     if FileExists (filename) then
        sl.LoadFromFile (filename);

     result := multi_replace_from_list (text, sl);

     sl.Free;
end;


function delete_emply_lines (const text: string): String;
var
   i, c: integer;
   sl: TStringList;
   s: TStringList;
begin
     result := '';
     if text = '' then
        exit;

     sl := TStringList.Create;
     sl.Text := text;

     c := sl.Count - 1;

     s := TStringList.Create;

     s.BeginUpdate;

     for i := 0 to c do
         if Sysutils.Trim (sl[i]) <> '' then
            s.Add (sl[i]);

     s.EndUpdate;

     result := s.Text;

     s.Free;
     sl.Free;
end;


function delete_emply_lines_w (const text: widestring): widestring;
var
   i, c: integer;
   sl: TWideStringList;
   s: TWideStringList;

begin
     result := '';
     if text = '' then
        exit;

     sl := TWideStringList.Create;
     sl.Text := text;

     c := sl.Count - 1;

     s := TWideStringList.Create;

     s.BeginUpdate;

     for i := 0 to c do
         if Sysutils.Trim (sl[i]) <> '' then
            s.Add (sl[i]);

     s.EndUpdate;

     result := s.Text;

     s.Free;
     sl.Free;
end;


function extract_words (const text: string): TStrings;
var
   i, c: integer;
   a, b: integer;
   word_start: boolean;
   s: string;
begin
     result := nil;

     if text = '' then
        exit;

     result := TStringList.Create;
     c := length (text);
     word_start := false;

     i := 1;

     while i <> c do
          begin

               if ((CharIsAlphaNum (text[i])) and (not word_start)) then
                  begin
                       a := i;
                       word_start := true;
                       i := i + 1;
                       continue;
                   end;

                if ((not CharIsAlphaNum (text[i])) and word_start) then
                   begin
                        b := i;
                        s := Copy (text, a, (b - a));
                        result.add (s);
                        word_start := false;

                        while (CharIsWhiteSpace (text[i])) do
                              i := i + 1;
                   end
                else
                    i := i + 1;
          end;
end;


function build_path (const pathtofile: string; sel: string): string;
begin
     if Pos (':\', sel) <> 0
        then
            begin
                 result := sel;
                 exit;
            end;

     if sel[1] = '\' then
        sel := copy (sel, 2, length (sel) - 1);

     if Pos ('/', sel) <> 0 then
         begin
              if sel[1] <> '/' then
                 sel := '/' + sel;

              result := sel;

              StrReplace (result, '/','\', [rfReplaceAll]);

              result := ExtractFilePath (pathtofile) + result;
              Exit;
        end;

   result := ExtractFilePath (pathtofile) + sel;
end;


function strings_sort_w (const s: widestring): widestring;
var
   sl: TWideStringList;
begin
     sl := TWideStringList.Create;
     sl.Text := s;
     sl.Sort;
     result := sl.Text;
     sl.Free;
end;


function NumStrings (const value: string; fs, metachar: string): string;
var
    i, c, j, step, start:integer;
    t, z: string;
    tsl: TStringList;
    tolow, isstep, isstart: boolean;
    sl: TStrings;

begin
     sl := TStringList.create;;
     sl.Text := value;

     c := sl.count - 1;

     tolow := false;
     isstep := false;
//     isroman := false;

     step := 1;
     tsl := TStringList.Create;
     StrToStrings (fs, ' ', tsl);

     z := tsl.values[metachar + 'step'];
     if z <> '' then
        begin
             step := StrToInt(z);
             isstep := true;
        end;

  //   z := tsl.values[metachar + 'roman'];
    // if StrLoCase (z) = 'true' then
      //  isroman := true;

     z := tsl.values[metachar + 'tolow'];
     if AnsiLowerCase (z) = 'true' then
        tolow := true;

     z := tsl.values[metachar + 'start'];
     if z <> '' then
        begin
             start := StrToInt (z);
             isstart := true;
        end;

     if isstart then
        begin
             if tolow then
                j := sl.count
              else
                  j := start;
            end
     else
         if tolow then
            j := sl.count
         else
             j := 1;

     fs := StrBetween (fs, '{', '}');

     for i := 0 to c do
         begin
              t := fs;
              StrReplace (t, metachar + 'string', sl[i], []);

               if isstep then
                  j := (i + 1) * step
               else
                   begin
                        if tolow then
                           j := j - 1
                        else
                            j := j + 1;
                   end;

               //if isroman then
                 //             StrReplace (t, metachar+'counter',IntToRoman(j));
//              else
                StrReplace (t, metachar + 'counter', IntToStr(j));
                sl[i] := t;
            end;

    result := sl.Text;
    sl.Free;
    tsl.free;
end;



function NumStrings_w (const value: widestring; fs, metachar: string): widestring;
var
    i, c, j, step, start:integer;
    t, z: string;
    tsl: TStringList;
    tolow, isstep, isstart: boolean;
    sl: TWideStringList;

begin
     sl := TWideStringList.create;
     sl.text := value;
     c := sl.count - 1;

     tolow := false;
     isstep := false;
//     isroman := false;

     step := 1;
     tsl := TStringList.Create;
     StrToStrings (fs, ' ', tsl);

     z := tsl.values[metachar + 'step'];
     if z <> '' then
        begin
             step := StrToInt(z);
             isstep := true;
        end;
                   {
     z := tsl.values[metachar + 'roman'];
     if StrLoCase (z) = 'true' then
        isroman := true;
                    }
     z := tsl.values[metachar + 'tolow'];
     if AnsiLowerCase (z) = 'true' then
        tolow := true;

     z := tsl.values[metachar + 'start'];
     if z <> '' then
        begin
             start := StrToInt (z);
             isstart := true;
        end;

     if isstart then
        begin
             if tolow then
                j := sl.count
              else
                  j := start;
            end
     else
         if tolow then
            j := sl.count
         else
             j := 1;

     fs := StrBetween (fs, '{', '}');

     for i := 0 to c do
         begin
              t := fs;
              t := AnsiReplaceStr (fs, metachar + 'string', sl[i]);

               if isstep then
                  j := (i + 1) * step
               else
                   begin
                        if tolow then
                           j := j - 1
                        else
                            j := j + 1;
                   end;

               //if isroman then
                 //             StrReplace (t, metachar+'counter',IntToRoman(j));
//              else
                t := AnsiReplaceStr (t, metachar + 'counter', IntToStr (j));
                sl[i] := t;
            end;

    result := sl.text;
    tsl.free;
    sl.free;
end;


function reverse_lines (const text: string): string;
var
   sl: TStringList;
   sl2: TStringList;
   i, c: integer;
begin
     sl := TStringList.create;
     sl2 := TStringList.create;
     sl.Text := text;

     sl2.BeginUpdate;
     c := sl.count - 1;
     for i := c downto 0 do
         sl2.add (sl[i]);

     sl2.EndUpdate;
     result := sl2.Text;
     sl.free;
     sl2.Free;
end;


function reverse_lines_w (const text: widestring): widestring;
var
   sl: TWideStringList;
   sl2: TWideStringList;
   i, c: integer;
begin
     sl := TWideStringList.create;
     sl2 := TWideStringList.create;
     sl.Text := text;

     sl2.BeginUpdate;
     c := sl.count - 1;
     for i := c downto 0 do
         sl2.add (sl[i]);

     sl2.EndUpdate;
     result := sl2.Text;
     sl.free;
     sl2.Free;
end;


function str_extract_each_between (const text: string; sep: char): string;
var
   sl: TStringList;
   i, c: integer;
begin
     sl := TStringList.create;
     sl.text := text;
     sl.BeginUpdate;
     c := sl.Count - 1;

     for i := 0 to c do
         sl[i] := StrBetween(sl[i], sep, sep);

     sl.EndUpdate;
     result := sl.text;
     sl.free;
end;


function wide_strings_sort (const text: widestring): widestring;
var
   sl: TWideStringList;
begin
     sl := TWideStringList.Create;
     sl.text := text;
     sl.Sort;
     result := sl.text;
     sl.free;

end;


function NumStrings2 (const value: string; fs, metachar: string): string;
var
    i, c, j, step, start:integer;
    t, z: string;
    tsl: TStringList;
    tolow, isstep, isstart: boolean;
    sl: TStrings;

begin
     sl := TStringList.create;;
     sl.Text := value;

     c := sl.count - 1;

     tolow := false;
     isstep := false;

     step := 1;
     tsl := TStringList.Create;
     StrToStrings (fs, '{', tsl);

     z := tsl.values[metachar + 'step'];
     if z <> '' then
        begin
             step := StrToInt(z);
             isstep := true;
        end;
                   {
     z := tsl.values[metachar + 'roman'];
     if StrLoCase (z) = 'true' then
        isroman := true;
                    }
     z := tsl.values[metachar + 'tolow'];
     if AnsiLowerCase (z) = 'true' then
        tolow := true;

     z := tsl.values[metachar + 'start'];
     if z <> '' then
        begin
             start := StrToInt (z);
             isstart := true;
        end;

     if isstart then
        begin
             if tolow then
                j := sl.count
              else
                  j := start;
            end
     else
         if tolow then
            j := sl.count
         else
             j := 1;

     fs := StrBetween (fs, '{', '}');

     for i := 0 to c do
         begin
              t := fs;
              StrReplace (t, metachar + 'string', sl[i], []);

               if isstep then
                  j := (i + 1) * step
               else
                   begin
                        if tolow then
                           j := j - 1
                        else
                            j := j + 1;
                   end;

               //if isroman then
                 //             StrReplace (t, metachar+'counter',IntToRoman(j));
//              else
                StrReplace (t, metachar + 'counter', IntToStr(j));
                sl[i] := t;
            end;

    result := sl.Text;
    sl.Free;
    tsl.free;
end;


function str_trim_from_char_right (const text: string; sep: string): string;
var
   sl: TStringList;
   i, c, x: integer;
begin
     sl := TStringList.create;
     sl.text := text;
     sl.BeginUpdate;
     c := sl.Count - 1;

     for i := 0 to c do
         begin
              x := ANSIPos (sep, sl[i]);
              if x = 0 then
                continue;

              sl[i] := AnsiLeftStr (sl[i], x);
         end;

     sl.EndUpdate;
     result := sl.text;
     sl.free;
end;


function html_to_text (const text: string): string;
var
   sl: TStringList;
   i, c: integer;
begin
     sl := TStringList.Create;
     sl.Text := text;
     c := sl.Count - 1;
     for i := 0 to c do
         sl[i] := '<p class="p1">' + sl[i] + '</p>';

     sl.Insert (0, '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">'+ #13#10 +
'<html>' + #13#10 +
'<head>' + #13#10 +
'<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">' + #13#10 +
'<style type="text/css">' + #13#10 +
'.p1' + #13#10 +
'{' + #13#10 +
'margin: 0px 0px 0px 0px;' + #13#10 +
'padding: 0px 0px 0px 0px;' + #13#10 +
'text-indent: 1.5em;' + #13#10 +
'text-align: justify;' + #13#10 +
'}' + #13#10 +
'</style>' + #13#10 +
'<title></title>' + #13#10 +
'</head>' + #13#10 +
'<body>');

sl.add ('</body>' + #13#10 + '</html>');

     result := sl.Text;
     sl.Free;
end;


function html_to_text_w (const text: widestring): WideString;
var
   sl: TWideStringList;
   i, c: integer;
begin
     sl := TWideStringList.Create;
     c := sl.count - 1;
     for i := 0 to c do
         sl[i] := '<p class="p1">' + sl[i] + '</p>';

     sl.Insert (0, '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">'+ #13#10 +
'<html>' + #13#10 +
'<head>' + #13#10 +
'<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">' + #13#10 +
'<style type="text/css">' + #13#10 +
'.p1' + #13#10 +
'{' + #13#10 +
'margin: 0px 0px 0px 0px;' + #13#10 +
'padding: 0px 0px 0px 0px;' + #13#10 +
'text-indent: 1.5em;' + #13#10 +
'text-align: justify;' + #13#10 +
'}' + #13#10 +
'</style>' + #13#10 +
'<title></title>' + #13#10 +
'</head>' + #13#10 +
'<body>');

   sl.add ('</body>' + #13#10 + '</html>');

     result := sl.Text;
     sl.Free;
end;


end.
