unit u_unitaz;

{
 TEA   
  
       (public domain)
}

//created 25 april 2001  19:39
//v2 made at 14 feb 2003
//v3 - 21 feb 2006


interface

uses classes, sysutils;

Type

TRListItem = record

  value: shortstring;
  count: longint;

end;

PRListItem = ^TRListItem;


CWordsMass = class

  words: TList;
  global_count: integer;
  unique_count: integer;

  constructor Create;
  destructor Destroy; override;

  procedure Xecute (const w: string);
  procedure SortByQuantity;
  function MiddleWordLenByGlobal: string;
  function MiddleWordLenByLocal: string;
  procedure CheckOnNewEntry (const s: string); virtual;
  function MakeNewItem (const s:string): PRListItem;

end;

CWordsUnCaseMass = class (CWordsMass)

  procedure CheckOnNewEntry (const s :string); override;

end;



CAStat = class

  wm: CWordsUnCaseMass;
  s_in: string;
  mode: byte;

  procedure Xecute (sout:TStrings; sort_by_quantity: boolean); virtual; abstract;

end;


TAWords = array [0..255] of TList;

CHashMass = class

  words: TAWords;
  sum_len: longint;

  function MakeNewItem (const s: string): PRListItem;
  constructor Create;
  destructor Destroy; override;
  procedure AddNewWord (s: string);
  function GetWordsTotal: integer;
  function GetWordsUnique: integer;
  procedure Xecute(const w: string);
  procedure SortByQuantity (var l: TList);

end;



CNewStat=class (CAStat)

  wm:CHashMass;

  constructor Create (const s:string);
  destructor Destroy; override;
  procedure Xecute (sout: TStrings; sort_by_quantity: boolean); override;
end;


function CharsCount(const s:string; c:char): integer;


implementation

uses
    dialogs, jclstrings, u_strings;


function CharsCount (const s: string; c: char): integer;
var
   i, size: integer;
begin
     Result := 0;
     size := length (s);
     if size = 0 then
        exit;
     for i := 1 to size do
         if s[i] = c then
            Result := Result + 1;
end;


constructor CWordsMass.Create;
begin
     words := Tlist.Create;
     global_count := 0;
     unique_count := 0;
end;


function CWordsMass.MiddleWordLenByGlobal: string;
var
   i, w, size: integer;
begin
     w := 0;
     size := words.Count - 1;

     for i := 0 to size do
         w := w + PRListItem(words.items[i]).count * (Length (PRListItem(words.items[i]).value) - 1);

     Result := FloatToStr (w / global_count);
end;


function CWordsMass.MiddleWordLenByLocal: string;
var
   i, w, size: integer;
begin
     w := 0;
     size := words.Count - 1;

     for i := 0 to size do
        w := w + PRListItem(words.items[i]).count * (Length (PRListItem(words.items[i]).value) - 1);

     Result := FloatToStr (w / unique_count);
end;


destructor CWordsMass.Destroy;
var
   i, size: integer;
begin
    size := words.Count - 1;
    for i := 0 to size do
        Dispose (words.items[i]);
    words.free;
    Inherited Destroy;
end;


function CWordsMass.MakeNewItem(const s: string): PRListItem;
var
   t: PRListItem;
begin
     New (t);
     t^.value := s;
     t^.count := 1;
     result := t;
     unique_count := unique_count + 1;
end;


procedure CWordsMass.CheckOnNewEntry (const s: string);
var
   i, size: integer;
begin
     if words.Count = 0 then
        begin
             words.Add (MakeNewItem (s));
             Exit;
        end;

     size := words.Count - 1;

     for i := 0 to size do
         if PRListItem(words[i]).value = s then
            begin
                 Inc (PRListItem(words.items[i]).count);
                 Exit;
            end;

    // 
     words.Add (MakeNewItem (s));
end;


procedure CWordsMass.SortByQuantity;
var
   i, j, size: integer;
   t: TRListItem;
begin
     size := words.Count - 2;

     for j := 0 to size do
         for i := 0 to size do
            if PRListItem(words[i]).count < PRListItem(words[i + 1]).count
               then
                   begin
                        t.value := PRListItem(words[i]).value;
                        t.count := PRListItem(words[i]).count;
                        PRListItem(words[i]).count := PRListItem(words[i + 1]).count;
                        PRListItem(words[i]).value := PRListItem(words[i + 1]).value;
                        PRListItem(words[i + 1]).count := t.count;
                        PRListItem(words[i + 1]).value := t.value;
                   end;
end;


procedure CWordsMass.Xecute (const w: string);
var
   sl: TStrings;
   i, c: integer;
begin
     if w = '' then
        exit;

     sl := extract_words (w);
     if sl = nil then
        exit;

     c := sl.Count - 1;
     if c > 0 then
        for i := 0 to c do
           begin
                CheckOnNewEntry (sl[i]);
                global_count := global_count + 1;
           end;

     sl.Free;
end;


procedure CWordsUnCaseMass.CheckOnNewEntry (const s:string);
var
   i, size: integer;
begin
     if words.Count = 0 then
        begin
             words.Add (MakeNewItem (jclstrings.StrLower (s)));
             Exit;
        end;

     size := words.Count - 1;

     for i := 0 to size do
         if PRListItem(words[i]).value = jclstrings.StrLower (s) then
            begin
                 Inc (PRListItem(words.items[i]).count);
                 Exit;
            end;

     // 
     words.Add (MakeNewItem (jclstrings.StrLower (s)));
end;


constructor CHashMass.Create;
var
   b: byte;
begin
     inherited Create;

     for b := 0 to 255 do
         words[b] := TList.create;

    sum_len := 0;
end;


procedure FreeItem (var t:TList);
var
   i, size: integer;
begin
     size := t.Count - 1;
     for i := 0 to size do
         Dispose (t.items[i]);
     t.free;
end;


destructor CHashMass.Destroy;
var
   b: byte;
begin
     inherited;
     for b := 0 to 255 do
         FreeItem (words[b]);
end;


function CHashMass.MakeNewItem (const s: string): PRListItem;
var
   t: PRListItem;
begin
     New (t);
     t^.value := s;
     t^.count := 1;
     result := t;
end;


procedure CHashMass.AddNewWord (s: string);
var
   index: byte;
   i, c: integer;
   l: TList;

begin
     if s = '' then
        exit;

     index := byte (s[1]);
     s := jclstrings.StrLower (s);
     l := words[index];
     c := l.count - 1;

     //if ct.uni_middle_len then

     sum_len := sum_len + length (s);

     if c = -1 then
        begin
             l.Add (MakeNewItem (s));
             Exit;
        end;

     for i := 0 to c do
         if PRListItem(l.items[i]).value = s
            then
                begin
                     Inc (PRListItem(l.items[i]).count);
                     exit;
                end;

     l.Add (MakeNewItem (s));
end;


function CHashMass.GetWordsTotal: integer;
var
   b: byte;
   i, c: integer;
begin
     result := 0;

     for b := 0 to 255 do
         begin
              c := words[b].count - 1;

              if c = 0 then
                 continue;

              for i:=0 to c do
                  result := result + PRListItem(words[b].items[i]).count;

         end;
end;


function CHashMass.GetWordsUnique: integer;
var
   b: byte;
begin
     result := 0;
     for b := 0 to 255 do
         result := result + words[b].count;
end;


procedure CHashMass.Xecute (const w: string);
var
   sl: TStrings;
   i, c: integer;
begin
     if w = '' then
        exit;

     sl := extract_words (w);
     if sl = nil then
        exit;

     c := sl.Count - 1;
     if c > 0 then
        for i := 0 to c do
            AddNewWord (sl[i]);

     sl.Free;
end;



constructor CNewStat.Create (const s: string);
begin
     inherited Create;
     wm := CHashMass.Create;
     if s = '' then
        s_in := 'NULL'
     else
         s_in := s;
end;


destructor CNewStat.Destroy;
begin
     inherited;
     wm.free;
end;


procedure CNewStat.Xecute (sout: TStrings; sort_by_quantity: boolean);
var
   start_time: TDateTime;
   i, c: integer;
   tot, uni: integer;
   b: byte;
   l: TList;
   outlist: TList;
   t: string;
   ti: PRListItem;
begin
     if wm = nil then
        exit;

     sout.clear;

     start_time := Now;
     sout.Add (' ...');

     wm.Xecute (s_in);

     if mode = 0 then
        begin
             sout.Add (': ');
             sout.BeginUpdate;

             tot := wm.GetWordsTotal;
             uni := wm.GetWordsUnique;

             sout.Add (' : ' + IntToStr (tot));
             sout.Add (' : ' + IntToStr (uni));
             sout.Add ('  -   : ' + FloatToStr (tot / uni));
             sout.Add ('  : ' + FloatToStr (wm.sum_len / tot));

             sout.Add('');
             sout.Add(' : ');

             if not sort_by_quantity then
                begin
                     for b := 0 to 255 do
                        begin
                             l := wm.words[b];
                             c := l.count - 1;
                             if c = -1 then
                                continue;

                             for i := 0 to c do
                                 begin
                                      t := PRListItem(l.Items[i]).value;
                                      t := t + '    ' + IntToStr (PRListItem(l.Items[i]).count);
                                      sout.Add (t);
                                 end;
                         end;

                     sout.Add (' : ' + TimeToStr((now - start_time)));

                     sout.EndUpdate;
                     exit;
                end;

             //else sort by q

             outlist := TList.Create;

             for b := 0 to 255 do
                 begin
                      l := wm.words[b];
                      c := l.count - 1;
                      if c = -1 then
                         continue;

                      for i := 0 to c do
                          begin
                               New (ti);
                               ti^.value := PRListItem(l.Items[i]).value;
                               ti^.count := PRListItem(l.Items[i]).count;
                               outlist.Add (ti);
                          end;
                 end;


            sout.Add (' : ');
            wm.SortByQuantity (outlist);

            for i := 0 to outlist.Count - 1 do
            begin
                 t := PRListItem(outlist.Items[i]).value;
                 t := t + '    ' + IntToStr (PRListItem(outlist.Items[i]).count);
                 sout.Add (t);
            end;

            sout.Add(' .');
            FreeItem (outlist);

            sout.Add (' : ' + TimeToStr ((now - start_time)));
            sout.EndUpdate;
        end;


    if mode = 1 then
       begin
            sout.beginUpdate;

            for b := 0 to 255 do
                begin
                     l := wm.words[b];
                     c := l.count - 1;
                     if c = -1 then
                        continue;

                     for i := 0 to c do
                         begin
                              t := PRListItem(l.Items[i]).value;
                              sout.Add (t);
                         end;
                end;


//            sout.Delete (0);
            sout.EndUpdate;
            exit;
       end;
end;


procedure CHashMass.SortByQuantity (var l: TList);
var
   i, j, size: integer;
   t: TRListItem;
begin
     size := l.Count - 2;
     for j := 0 to size do
     for i := 0 to size do
         if PRListItem(l[i]).count < PRListItem(l[i + 1]).count then
            begin
                 t.value := PRListItem(l[i]).value;
                 t.count := PRListItem(l[i]).count;
                 PRListItem(l[i]).count := PRListItem(l[i + 1]).count;
                 PRListItem(l[i]).value := PRListItem(l[i + 1]).value;
                 PRListItem(l[i + 1]).count := t.count;
                 PRListItem(l[i + 1]).value := t.value;
            end;
end;


end.

